package com.example.uart2;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.text.SimpleDateFormat;
import java.util.Date;

import android.util.Log;

import com.example.uart2.bean.Uart;




public class MonitorAnalysis_SSTLR1{
	
	public Uart convertArray(byte[] bs,int size) {
		if(!((bs[0]&0xFF)==255&&(bs[1]&0xFF)==255&&(bs[2]&0xFF)==255&&(bs[3]&0xFF)==255&&(bs[4]&0xFF)==255))return null;
		if((byte)(bs[5]^bs[6]^bs[7]^bs[8]^bs[9]^bs[10])!=bs[11]){
			Log.w("data", "校验错误");
			return null;
		}
		if(bs[6] != (byte)0x01)return null;
		Uart u=new Uart();
		u.setNo(String.valueOf(getInt(bs[7],bs[8],bs[9],bs[10])));
		//u.setNo(String.valueOf(byteArrayToInt(new byte[]{bs[7],bs[8],bs[9],bs[10]},0)));
		//u.setTemp(getFloat(bs[9],bs[10],bs[11],bs[12])+"");
		//u.setHumi(getFloat(bs[13],bs[14],bs[15],bs[16])+"");
		//u.setVoltage((bs[6]&0x80)==0x80?"�?:"正常");
		u.setTime(new SimpleDateFormat("hh:mm:ss").format(new Date()));
		u.setType((bs[6]&0x7f)+"");
		return u;
	}
	
	private float getFloat(byte b1,byte b2,byte b3,byte b4){
		byte[] b=new byte[]{b1,b2,b3,b4};
	    ByteBuffer buf=ByteBuffer.allocateDirect(4); //无额外内存的直接缓存
	    buf=buf.order(ByteOrder.LITTLE_ENDIAN);//默认大端，小端用这行
	    buf.put(b);
	    buf.rewind();
	    return ((float)((int)(buf.getFloat()*100)))/100;
	}
	
	private long getInt(byte b1,byte b2,byte b3,byte b4){
		byte[] b=new byte[]{(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,b1,b2,b3,b4};
		ByteBuffer buf=ByteBuffer.allocateDirect(8); //无额外内存的直接缓存
		//buf=buf.order(ByteOrder.LITTLE_ENDIAN);//默认大端，小端用这行
		buf.put(b);
		buf.rewind();
		return buf.getLong();
	}
	
	public static int byteArrayToInt(byte[] b, int offset) {
	       int value= 0;
	       for (int i = 0; i < 4; i++) {
	           int shift= (4 - 1 - i) * 8;
	           value +=(b[i + offset] & 0x000000FF) << shift;
	       }
	       return value;
	 }
	
	public int getInt(byte b1,byte b2,boolean fuhao){
		if(!fuhao)return ((b1&0xFF)<<8)|(b2&0xFF);
		else{
			int b = ((b1&0xFF)<<8)|(b2&0xFF);
			if(b >= 0x8000){
				 //负�?
				b = ~b + 1;//取反�?
				b = b & 0xFFFF;//取低2字节
				b *= -1;
			}
			//int v=(((b1&0x7f)<<8)|(b2&0xFF))*((b1 & 0x80)==0?1:-1);
			return b;
		}
	}

}
